<?php
/**
 * Order view block
 *
 * @category   Turnkeye
 * @package    Turnkeye_Xcartorders
 * @author     Viacheslav Fedorenko <v.fedorenko@turnkeye.com>
 */
class Turnkeye_Xcartorders_Block_Adminhtml_Xcartorder_View extends Mage_Adminhtml_Block_Widget_Form_Container
{

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->_objectId    = 'id';
        $this->_controller  = 'adminhtml_xcartorder';
        $this->_blockGroup  = 'turnkeye_xcartorders';
        $this->_mode        = 'view';

        parent::__construct();
        $this->_removeButton('delete');
        $this->_removeButton('reset');
        $this->_removeButton('save');
        $this->setId('turnkeye_xcartorders_view');
    }

    /**
     * Retrieve order model object
     *
     * @return Mage_Sales_Model_Order
     */
    public function getOrder()
    {
        return Mage::registry('xcart_order');
    }

    /**
     * Retrieve Order Identifier
     *
     * @return int
     */
    public function getOrderId()
    {
        return $this->getOrder()->getId();
    }

    public function getHeaderText()
    {
        if ($_extOrderId = $this->getOrder()->getExtOrderId()) {
            $_extOrderId = '[' . $_extOrderId . '] ';
        } else {
            $_extOrderId = '';
        }
        return Mage::helper('sales')->__('Xcart Order # %s %s | %s', $this->getOrder()->getId(), $_extOrderId, $this->formatDate(date("Y-m-d H:i:s", $this->getOrder()->getDate()), 'medium', true));
    }

}