<?php
/**
 * Order view tabs block
 *
 * @category   Turnkeye
 * @package    Turnkeye_Xcartorders
 * @author     Viacheslav Fedorenko <v.fedorenko@turnkeye.com>
 */
class Turnkeye_Xcartorders_Block_Adminhtml_Xcartorder_View_Tabs extends Mage_Adminhtml_Block_Widget_Tabs
{
    /**
     * Retrieve available order
     *
     * @return Turnkeye_Xcartorders_Model_Order
     */
    public function getOrder()
    {
        if ($this->hasOrder()) {
            return $this->getData('order');
        }
        if (Mage::registry('xcart_order')) {
            return Mage::registry('xcart_order');
        }
        Mage::throwException(Mage::helper('sales')->__('Cannot get the order instance.'));
    }

    /**
     * Construct
     */
    public function __construct()
    {
        parent::__construct();
        $this->setId('turnkeye_xcartorders_view_tabs');
        $this->setDestElementId('turnkeye_xcartorders_view');
        $this->setTitle(Mage::helper('turnkeye_xcartorders')->__('Order View'));
    }

}
