<?php
/**
 * adminhtml Orders controller
 *
 * @category   Turnkeye
 * @package    Turnkeye_Xcartorders
 * @author     Viacheslav Fedorenko <v.fedorenko@turnkeye.com>
 */

class Turnkeye_Xcartorders_Adminhtml_XcartorderController extends Mage_Adminhtml_Controller_Action
{

    /**
     * get helper
     *
     * @return Turnkeye_Xcartorders_Helper_Data
     */
    protected function _getHelper()
    {
        return Mage::helper('turnkeye_xcartorders');
    }

    /**
     * init
     *
     * @return Turnkeye_Xcartorders_Adminhtml_XcartorderController
     */
    protected function _initAction()
    {
        $this->loadLayout()
            ->_setActiveMenu('sales/turnkeye_xcartorders')
            ->_addBreadcrumb($this->_getHelper()->__('Xcart Orders'), $this->_getHelper()->__('Xcart Orders'));

        return $this;
    }

    /**
     * view orders list action
     */
    public function indexAction()
    {
        $this->_initAction()
            ->renderLayout();
    }

    /**
     * view order action
     */
    public function viewAction()
    {
        Mage::register('xcart_order', Mage::getModel('turnkeye_xcartorders/order')->load($this->getRequest()->getParam('id')));
        $this->_initAction()
            ->renderLayout();
    }

}