<?php
/**
 * Orders controller
 *
 * @category   Turnkeye
 * @package    Turnkeye_Xcartorders
 * @author     Viacheslav Fedorenko <v.fedorenko@turnkeye.com>
 */

class Turnkeye_Xcartorders_OrderController extends Mage_Core_Controller_Front_Action
{
    /**
     * order list action
     */
    public function indexAction()
    {
        if (!Mage::getSingleton('customer/session')->getCustomer() || !Mage::getSingleton('customer/session')->getCustomer()->getId()) {
            $this->_redirect('customer/account');
            return;
        }
        $this->loadLayout();

        $this->getLayout()->getBlock('head')->setTitle($this->__('Previous Orders'));

        if ($block = $this->getLayout()->getBlock('customer.account.link.back')) {
            $block->setRefererUrl($this->_getRefererUrl());
        }
        $this->renderLayout();
    }

    /**
     * view order action
     */
    public function viewAction()
    {
        if (!Mage::getSingleton('customer/session')->getCustomer() || !Mage::getSingleton('customer/session')->getCustomer()->getId()) {
            $this->_redirect('customer/account');
            return;
        }

        $model = Mage::getModel('turnkeye_xcartorders/order')->load($this->getRequest()->getParam('order_id'));

        if ($model->getCustomerId() != Mage::getSingleton('customer/session')->getCustomer()->getId()) {
            $this->_redirect('customer/account');
            return;
        }

        $this->loadLayout();
        $this->getLayout()->getBlock('head')->setTitle($this->__('Order #' . $this->getRequest()->getParam('order_id')));
        $this->renderLayout();
    }

}
