<?php

require_once "app/Mage.php";
Mage::app();

/*
// Here move categories from the big file
$file = "export.csv";
$magento_file = "xcart_categories.csv";
$path = dirname(__FILE__) . DIRECTORY_SEPARATOR;

$fd = fopen($path . $file, "rb");
$delimiter = ";";
$found = false;
$mag_fd = fopen($path . $magento_file, "w+b");
while($row = fgetcsv($fd, 40960, $delimiter)) {
    if ($found) {
        if (count($row) == 1) {
            break;
        }

        fputcsv($mag_fd, $row);
    }
    if ('[CATEGORIES]' == $row[0]) {
        $found = true;
    }
}

fclose($fd);
fclose($mag_fd);
*/

$file = "xcart_categories.csv";
$path = dirname(__FILE__) . DIRECTORY_SEPARATOR;
$fd = fopen($path . $file, "rb");
$delimiter = ',';
$store_id = 1;
$default_attribute_set_id = Mage::getModel('catalog/category')->getDefaultAttributeSetId();

Mage::register('isSecureArea', true);

$header_arr = fgetcsv($fd, 10000, $delimiter);
$header = array();
foreach ($header_arr as $k => $v) {
    $header[$v] = $k;
}

$_cache_categories_path = array();
$_cache_xcart2magento = array();

/*
foreach (Mage::getModel('catalog/category')->getCollection()->getItems() as $i) {
    if ($i->getId() > 2) {
        $i->delete();
    }
}

exit;
*/


$_cache_xcart2id = array();
$sorted = $sorted_cats = array();

while ($row = fgetcsv($fd, 40960, $delimiter)) {
    $paths = explode('/', $row[$header['!CATEGORY']]);
    $cpath = count($paths);
    $name = array_pop($paths);
    if ($cpath == 1) {
        $parentId = 0;
    } else {
        if (!isset($_cache_xcart2id[join('/', $paths)])) {
            die ('Cannot find Xcart Category ID for ' . join('/', $paths));
        }

        $parentId = $_cache_xcart2id[join('/', $paths)];
    }

    $_cache_xcart2id[$row[$header['!CATEGORY']]] = $row[$header['!CATEGORYID']];
    if (!isset($sorted_cats[$parentId])) {
        $sorted_cats[$parentId] = array();
    }

    $sorted_cats[$parentId][$row[$header['!ORDERBY']] . '_' . $row[$header['!CATEGORYID']]] = $row;
}

foreach ($sorted_cats as $cats) {
    ksort($cats);
    foreach ($cats as $c) {
        $sorted[] = $c;
    }
}

foreach ($sorted as $row) {

    $paths = explode('/', $row[$header['!CATEGORY']]);
    $cpath = count($paths);
    $name = array_pop($paths);
    if ($cpath == 1) {
        $parentId = Mage::app()->getStore($store_id)->getRootCategoryId();
    } else {
        if (!isset($_cache_xcart2magento[join('/', $paths)])) {
            die ('Cannot find Magento Category ID for ' . join('/', $paths));
        }

        $parentId = $_cache_xcart2magento[join('/', $paths)];
    }

    $c = Mage::getModel('catalog/category')->getCollection()
        ->addAttributeToFilter('name', $paths[$cpath - 1])
        ->getFirstItem();
    if (!$c->getId()) {
        if (!isset($_cache_categories_path[$parentId])) {
            $_cache_categories_path[$parentId] = Mage::getModel('catalog/category')->load($parentId)->getPath();
        }

        $c = Mage::getModel('catalog/category')
            ->setName($name)
            ->setIsActive(($row[$header['!AVAIL']]=='Y')?1:0)
            ->setData('attribute_set_id', $default_attribute_set_id)

            ->setData('url_key', $row[$header['!CLEAN_URL']])
            ->setData('description', mb_convert_encoding($row[$header['!DESCR']], "UTF8"))
            ->setData('meta_title', mb_convert_encoding($row[$header['!TITLE_TAG']], "UTF8"))
            ->setData('meta_keywords', mb_convert_encoding($row[$header['!META_KEYWORDS']], "UTF8"))
            ->setData('meta_description', mb_convert_encoding($row[$header['!META_DESCRIPTION']], "UTF8"))

            ->setPath($_cache_categories_path[$parentId])
            ->setStoreId(0)
            ->save();
    }

    $_cache_xcart2magento[$row[$header['!CATEGORY']]] = $c->getId();
//    $structure = preg_split('#/+#', Mage::getModel('catalog/category')->load($c->getId())->getPath());
}

fclose($fd);