<?php


$path = dirname(__FILE__) . DIRECTORY_SEPARATOR;
define('XC_TIME', time());
require_once $path . "blowfish.php";
require_once "app/Mage.php";

Mage::app();
$merchant_password = false;
$blowfish = new ctBlowfish();

/**
 * Get crypted string type
 */
function func_get_crypt_type($str)
{
    global $encryption_types;

    $s = substr($str, 0, 1);

    if (!in_array((string)$s, $encryption_types))
        $s = false;

    return $s;
}

/**
 * Get encryptiond/decrtyption key
 */
function func_get_crypt_key($type)
{
    global $blowfish_key, $merchant_password;

    if ($type == 'B') {
        return $blowfish_key;

    } elseif ($type == 'C') {
        return $merchant_password;
    }

    return false;
}

function text_decrypt($s, $key = false)
{
    global $blowfish;

    if (strlen($s) == 0)
        return $s;

    // Parse crypted data
    $type = func_get_crypt_type($s);
    if ($type === false) {
        $type = 'N';
        $crc32 = false;

    } elseif (substr($s, 1, 1) == '-') {
        $crc32 = true;
        $s = substr($s, 2);

    } else {
        $crc32 = substr($s, 1, 8);
        $s = substr($s, 9);
    }

    // Blowfish
    if ($type == 'B' || $type == 'C') {
        if ($key === false)
            $key = func_get_crypt_key($type);

        if (!$blowfish) {
            error_log("The Blowfish service object is missing");
            return false;

        } elseif (empty($key)) {
            error_log("The key for the selected type ('".$type."') of encryption is missing");
            return false;
        }

        $result = trim(func_bf_decrypt($s, $key));
    } elseif ($type == 'N') {
        // Non-encrypted
        $result = $s;
    }

    // CRC32 check
    if ($crc32 === true) {
        // Inner CRC32
        $crc32 = substr($result, -8);
        $result = substr($result, 0, -8);
        if (func_crc32(md5($result)) != $crc32)
            $result = NULL;

    } elseif ($crc32 !== false) {
        // Outer CRC32
        if (func_crc32($result) != $crc32)
            $result = NULL;
    }

    return $result;
}

/**
 * Get CRC32 as HEX representation of integer
 */
function func_crc32($str)
{
    $crc32 = crc32($str);

    if (crc32('test') != -662733300 && $crc32 > 2147483647)
        $crc32 -= 4294967296;

    $hex = dechex(abs($crc32));

    return str_repeat('0', 8-strlen($hex)).$hex;
}

$file = "export.csv";
$magento_file = "magento_customer.csv";
$path = dirname(__FILE__) . DIRECTORY_SEPARATOR;
$fd = fopen($path . $file, "rb");
$delimiter = ";";
fgetcsv($fd);
fgetcsv($fd);
$header_arr = fgetcsv($fd, 10000, $delimiter);
$header = array();
foreach ($header_arr as $k => $v) {
    $header[$v] = $k;
}
//print_r($header); exit;
$counter = 0;
$used_emails = array();
$duplicate_emails = array();

$blowfish_key = 'hereyourblowfishkey';
$default_group_id = 1;
$default_store_id = 1;
$default_website_id = 1;
$default_website = 'base';
$default_store = 'default';
$default_created_in = 'Default Store View';
date_default_timezone_set('America/Los_Angeles');

$magento_header_arr = explode(',', 'email,_website,_store,confirmation,created_at,created_in,disable_auto_group_change,dob,firstname,gender,group_id,lastname,middlename,password_hash,prefix,rp_token,rp_token_created_at,store_id,suffix,taxvat,website_id,password,_address_city,_address_company,_address_country_id,_address_fax,_address_firstname,_address_lastname,_address_middlename,_address_postcode,_address_prefix,_address_region,_address_street,_address_suffix,_address_telephone,_address_vat_id,_address_default_billing_,_address_default_shipping_');
$magento_header = array();
foreach ($magento_header_arr as $k => $v) {
    $magento_header[$v] = $k;
}

$empty_magento_line = array();
foreach ($magento_header_arr as $k => $v) {
    $empty_magento_line[$k] = '';
}

$user_magento_line = $empty_magento_line;
$user_magento_line[$magento_header['_website']] = $default_website;
$user_magento_line[$magento_header['_store']] = $default_store;
$user_magento_line[$magento_header['created_in']] = $default_created_in;
$user_magento_line[$magento_header['disable_auto_group_change']] = 0;
$user_magento_line[$magento_header['group_id']] = $default_group_id;
$user_magento_line[$magento_header['store_id']] = $default_store_id;
$user_magento_line[$magento_header['website_id']] = $default_website_id;
$user_magento_line[$magento_header['_address_default_billing_']] = 1;

$regions = array();
foreach (Mage::getModel('directory/region')->getCollection() as $r) {
    if (!isset($regions[$r->getCountryId()])) {
        $regions[$r->getCountryId()] = array();
    }

    $regions[$r->getCountryId()][$r->getCode()] = $r->getDefaultName();
}

$association = array(
    '!B_TITLE' => '_address_prefix',
    '!B_FIRSTNAME' => '_address_firstname',
    '!B_LASTNAME' => '_address_lastname',
    '!B_ADDRESS' => '_address_street',
    '!B_CITY' => '_address_city',
    '!B_COUNTRY' => '_address_country_id',
    '!B_ZIPCODE' => '_address_postcode',
    '!COMPANY' => '_address_company',
    '!TITLE' => 'prefix',
    '!FIRSTNAME' => 'firstname',
    '!LASTNAME' => 'lastname',
    '!EMAIL' => 'email',
    '!PHONE' => '_address_telephone',
    '!FAX' => '_address_fax',
);

$association_shipping = array(
    '!S_TITLE' => '_address_prefix',
    '!S_FIRSTNAME' => '_address_firstname',
    '!S_LASTNAME' => '_address_lastname',
    '!S_ADDRESS' => '_address_street',
    '!S_CITY' => '_address_city',
    '!S_COUNTRY' => '_address_country_id',
    '!S_ZIPCODE' => '_address_postcode',
    '!COMPANY' => '_address_company',
    '!PHONE' => '_address_telephone',
    '!FAX' => '_address_fax',
);

$xcart_address_fields = array(
    'TITLE',
    'FIRSTNAME',
    'LASTNAME',
    'ADDRESS',
    'ADDRESS_2',
    'CITY',
    'STATE',
    'COUNTRY',
    'ZIPCODE',
);

$mag_fd = fopen($path . $magento_file, "w+b");
fputcsv($mag_fd, $magento_header_arr);
while($row = fgetcsv($fd, 40960, $delimiter)) {
    if (count($row) == 1) {
        break;
    }

    if (0 === strpos($row[$header['!LOGIN']], "anonymous")) {
        continue;
    }
    if (0 === strpos($row[$header['!LOGIN']], "guest ")) {
        continue;
    }
    if (0 === strpos($row[$header['!LOGIN']], "guest-")) {
        continue;
    }
    if ('C' != $row[$header['!USERTYPE']]) {
        continue;
    }

    $email = trim(strtolower($row[$header['!EMAIL']]));


    // Here we found duplicate emails
    if (isset($used_emails[$email])) {
        if (!isset($duplicate_emails[$email])) {
            $duplicate_emails[$email] = 1;
        }

        $duplicate_emails[$email]++;
        continue;
    }

    $used_emails[$email] = true;



    $new_row = $user_magento_line;
    foreach ($association as $xcart_field => $magento_field) {
        $new_row[$magento_header[$magento_field]] = $row[$header[$xcart_field]];
    }

    $new_row[$magento_header['email']] = $email;
    if (!$new_row[$magento_header['_address_firstname']]) {
        $new_row[$magento_header['_address_firstname']] = $row[$header['!FIRSTNAME']];
    }

    if (!$new_row[$magento_header['_address_lastname']]) {
        $new_row[$magento_header['_address_lastname']] = $row[$header['!LASTNAME']];
    }
    if (trim($row[$header['!B_ADDRESS_2']])) {
        $new_row[$magento_header['_address_street']] .= "\n" . trim($row[$header['!B_ADDRESS_2']]);
    }
    if (!isset($regions[$row[$header['!B_COUNTRY']]])) {
        $new_row[$magento_header['_address_region']] = $row[$header['!B_STATE']];
//        die('Regions for country ' . $row[$header['!B_COUNTRY']] . " not found");
    } else if ($row[$header['!B_STATE']] && !isset($regions[$row[$header['!B_COUNTRY']]][$row[$header['!B_STATE']]])) {
        $new_row[$magento_header['_address_region']] = '';
//        die('Regions ' . $row[$header['!B_STATE']] . ' for country ' . $row[$header['!B_COUNTRY']] . " not found");
    } else {
        $new_row[$magento_header['_address_region']] = $regions[$row[$header['!B_COUNTRY']]][$row[$header['!B_STATE']]];
    }

    $dec_pass = text_decrypt($row[$header['!PASSWORD']]);

    $new_row[$magento_header['password']] = $dec_pass;
    $new_row[$magento_header['created_at']] = date("Y-m-d H:i:s", strtotime($row[$header['!FIRST_LOGIN']]));
    $same_shipping = true;
    foreach ($xcart_address_fields as $xcart_field) {
        if ($row[$header['!B_' . $xcart_field]] != $row[$header['!S_' . $xcart_field]]) {
            $same_shipping = false;
            break;
        }
    }

    $new_address_row = null;
    if ($same_shipping) {
        $new_row[$magento_header['_address_default_shipping_']] = 1;
    } else {
        $new_address_row = $empty_magento_line;
        $new_address_row['_address_default_shipping_'] = 1;
        foreach ($association_shipping as $xcart_field => $magento_field) {
            $new_address_row[$magento_header[$magento_field]] = $row[$header[$xcart_field]];
        }

        if (!$new_address_row[$magento_header['_address_firstname']]) {
            $new_address_row[$magento_header['_address_firstname']] = $row[$header['!FIRSTNAME']];
        }

        if (!$new_address_row[$magento_header['_address_lastname']]) {
            $new_address_row[$magento_header['_address_lastname']] = $row[$header['!LASTNAME']];
        }
        if (trim($row[$header['!S_ADDRESS_2']])) {
            $new_address_row[$magento_header['_address_street']] .= "\n" . trim($row[$header['!S_ADDRESS_2']]);
        }
        if (!isset($regions[$row[$header['!S_COUNTRY']]])) {
            $new_address_row[$magento_header['_address_region']] = $row[$header['!S_STATE']];
//        die('Regions for country ' . $row[$header['!S_COUNTRY']] . " not found");
        } else if ($row[$header['!S_STATE']] && !isset($regions[$row[$header['!S_COUNTRY']]][$row[$header['!S_STATE']]])) {
            $new_address_row[$magento_header['_address_region']] = '';
//        die('Regions ' . $row[$header['!S_STATE']] . ' for country ' . $row[$header['!S_COUNTRY']] . " not found");
        } else {
            $new_address_row[$magento_header['_address_region']] = $regions[$row[$header['!S_COUNTRY']]][$row[$header['!S_STATE']]];
        }
    }
    $counter++;
    fputcsv($mag_fd, $new_row);
    if (!is_null($new_address_row)) {
        fputcsv($mag_fd, $new_address_row);
    }
}

echo count($duplicate_emails)."\n";
echo $counter . "\n";

//print_r($duplicate_emails); exit;

fclose($fd);
fclose($mag_fd);